<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Scopes/Synopsis/Lexer.html -->
<!-- this view was generated by Scope -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis::Lexer</title>
<link href="../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Scope">
<div class="navigation">
<span class="normal"><a href="../global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../NameIndex.html" >Name Index</a></span>
</div>
<!-- this part was generated by Heading -->
<div class="class-module">namespace <a href="../Synopsis.html" >Synopsis</a>
</div><div class="class-name">class Lexer

</div><div class="links"><div class="file">File: <a href="../../File/Synopsis/Lexer.hh.html" target="detail">../Synopsis/Lexer.hh</a></div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line22" ><img src="../../src-c++.png" alt="source code"/></a></div></div>   <div class="doc"><p>a Lexer reads tokens from a stream.</p>
</div>
<!-- this part was generated by Summary -->
<div class="summary">
<div class="heading">Public Typedefs Summary:</div>
<div class="item"><div class="synopsis">std::vector&lt;<a href="Token.html" >Token</a>&gt; <a class="name" id="Comments">Comments</a></div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mComments" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line29" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Structs Summary:</div>
<div class="item"><div class="synopsis">struct <a href="Lexer/InvalidChar.html" >InvalidChar</a></div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mInvalidChar" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line31" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Enums Summary:</div>
<div class="item"><div class="synopsis"><span class="name"><a href="Lexer.html#TokenSet" >TokenSet</a></span> C, CXX, GCC, MSVC</div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mTokenSet" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line28" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Define sets of token that are to be recognized as special
keywords (as opposed to identifiers).</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Public Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <span class="name"><a href="Lexer.html#Lexer_lBuffer_S_cint_r" >Lexer</a></span>(<a href="Buffer.html" >Buffer</a>*, int <span class="variable">tokenset</span> = <span class="value">CXX | GCC</span>)  </div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mLexer_lBuffer_S_cint_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line38" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Construct a Lexer on the given Buffer using the given
token set.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="get_token_lToken_A_r">get_token</a>(<a href="Token.html" >Token</a>&amp;)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mget_token_lToken_A_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line39" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="look_ahead_lsize_t_r">look_ahead</a>(size_t)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mlook_ahead_lsize_t_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line40" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="look_ahead_lsize_t_cToken_A_r">look_ahead</a>(size_t, <a href="Token.html" >Token</a>&amp;)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mlook_ahead_lsize_t_cToken_A_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line41" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;const&#160;char* <a class="name" id="save_l_r">save</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_msave_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line43" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="restore_lconst.char_S_r">restore</a>(const&#160;char*)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mrestore_lconst.char_S_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line44" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Lexer.html#Comments" >Comments</a> <a class="name" id="get_comments_l_r">get_comments</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mget_comments_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line46" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;unsigned&#160;long <span class="name"><a href="Lexer.html#origin_lconst.char_S_cstd_mstring_A_rconst" >origin</a></span>(const&#160;char*, std::string&amp;) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line50" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Return the origin of the given pointer
(filename and line number)</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Classes Summary:</div>
<div class="item"><div class="synopsis">class <a href="Lexer/Queue.html" >Queue</a></div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mQueue" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line54" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>a Queue is used to read in tokens from a stream
without consuming them</p>
</div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Typedefs Summary:</div>
<div class="item"><div class="synopsis">std::map&lt;std::string, <a href="Token.html#Type" >Token::Type</a>&gt; <a class="name" id="Dictionary">Dictionary</a></div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mDictionary" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line71" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Member functions Summary:</div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="rewind_lconst.char_S_r">rewind</a>(const&#160;char*)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mrewind_lconst.char_S_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line73" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_token_lconst.char_S_A_csize_t_A_r">read_token</a>(const&#160;char*&amp;, size_t&amp;)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_token_lconst.char_S_A_csize_t_A_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line75" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <span class="name"><a href="Lexer.html#fill_lsize_t_r" >fill</a></span>(size_t <span class="variable">o</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mfill_lsize_t_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line79" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>try to fill the token cache to contain
at least o tokens.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Lexer.html#skip_paren_l_r" >skip_paren</a></span>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_paren_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line82" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip till end of paren</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Lexer.html#skip_line_l_r" >skip_line</a></span>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_line_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line84" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip till end of line</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Lexer.html#skip_attribute_l_r" >skip_attribute</a></span>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_attribute_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line86" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __attribute__(...), ___asm__(...), ...</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <span class="name"><a href="Lexer.html#skip_extension_lconst.char_S_A_csize_t_A_r" >skip_extension</a></span>(const&#160;char*&amp;, size_t&amp;)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_extension_lconst.char_S_A_csize_t_A_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line88" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __extension__(...).</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Lexer.html#skip_asm_l_r" >skip_asm</a></span>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_asm_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line90" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __asm ...</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Lexer.html#skip_declspec_l_r" >skip_declspec</a></span>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_declspec_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line92" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __declspec(...).</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <span class="name"><a href="Lexer.html#skip_pragma_l_r" >skip_pragma</a></span>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_pragma_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line94" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __pragma(...);.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;char <a class="name" id="get_next_non_white_char_l_r">get_next_non_white_char</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mget_next_non_white_char_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line96" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_line_l_r">read_line</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_line_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line97" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="read_char_const_lunsigned.long_r">read_char_const</a>(unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_char_const_lunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line98" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="read_str_const_lunsigned.long_r">read_str_const</a>(unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_str_const_lunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line99" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_number_lchar_cunsigned.long_r">read_number</a>(char <span class="variable">c</span>, unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_number_lchar_cunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line100" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_float_lunsigned.long_r">read_float</a>(unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_float_lunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line101" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_identifier_lunsigned.long_r">read_identifier</a>(unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_identifier_lunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line102" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="screen_lconst.char_S_csize_t_r">screen</a>(const&#160;char* <span class="variable">identifier</span>, size_t <span class="variable">len</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mscreen_lconst.char_S_csize_t_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line103" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_separator_lchar_cunsigned.long_r">read_separator</a>(char <span class="variable">c</span>, unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_separator_lchar_cunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line104" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="single_char_op_lunsigned.char_r">single_char_op</a>(unsigned&#160;char <span class="variable">c</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_msingle_char_op_lunsigned.char_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line105" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="read_comment_lchar_cunsigned.long_r">read_comment</a>(char <span class="variable">c</span>, unsigned&#160;long <span class="variable">top</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mread_comment_lchar_cunsigned.long_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line106" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Private Data members Summary:</div>
<div class="item"><div class="synopsis"><a href="Buffer.html" >Buffer</a>* <a class="name" id="my_buffer">my_buffer</a></div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mmy_buffer" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line108" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="Lexer/Queue.html" >Queue</a> <a class="name" id="my_tokens">my_tokens</a></div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mmy_tokens" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line109" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="Lexer.html#Dictionary" >Dictionary</a> <a class="name" id="my_keywords">my_keywords</a></div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mmy_keywords" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line110" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="Token.html" >Token</a> <a class="name" id="my_token">my_token</a></div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mmy_token" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line111" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a href="Lexer.html#Comments" >Comments</a> <a class="name" id="my_comments">my_comments</a></div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mmy_comments" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line112" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"></div></div>
</div><!-- summary -->
<div class="summary">
<div class="heading">Enumerators Summary:</div>
<div class="item"><div class="synopsis"><a class="name" id="C">C</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="CXX">CXX</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="GCC">GCC</a></div> <div class="doc"></div></div>
<div class="item"><div class="synopsis"><a class="name" id="MSVC">MSVC</a></div> <div class="doc"></div></div>
</div><!-- summary -->
<!-- this part was generated by Inheritance -->
<!-- this part was generated by Detail -->
<div class="detail">
<div class="heading">Public Enums Details:</div>
<div class="item"><span class="keyword">enum</span> <a class="name" id="TokenSet">TokenSet</a><div class="enum"><div class="enumerator"><a class="name" id="C">C</a> = <span class="value">0x0</span></div><div class="enumerator"><a class="name" id="CXX">CXX</a> = <span class="value">0x01</span></div><div class="enumerator"><a class="name" id="GCC">GCC</a> = <span class="value">0x02</span></div><div class="enumerator"><a class="name" id="MSVC">MSVC</a> = <span class="value">0x04</span></div></div> <div class="doc"><p>Define sets of token that are to be recognized as special
keywords (as opposed to identifiers). They can be or'ed.
If CXX is not specified, the Lexer will operate in 'C mode'.</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Public Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;<i>constructor</i> <a class="name" id="Lexer_lBuffer_S_cint_r">Lexer</a>(<a href="Buffer.html" >Buffer</a>*, int <span class="variable">tokenset</span> = <span class="value">CXX | GCC</span>)  </div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mLexer_lBuffer_S_cint_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line38" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Construct a Lexer on the given Buffer using the given
token set. The default token set is CXX with GCC extensions.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;unsigned&#160;long <a class="name" id="origin_lconst.char_S_cstd_mstring_A_rconst">origin</a>(const&#160;char*, std::string&amp;) <span class="keyword">const</span> </div> <div class="xref"></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line50" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>Return the origin of the given pointer
(filename and line number)</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Classes Details:</div>
<div class="item"><div class="synopsis">class <a href="Lexer/Queue.html" >Queue</a></div> <div class="xref"><a href="../../XRef/xref0.html#Synopsis_mLexer_mQueue" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line54" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>a Queue is used to read in tokens from a stream
without consuming them</p>
</div></div>
</div><!-- detail -->
<div class="detail">
<div class="heading">Private Member functions Details:</div>
<div class="item"><div class="synopsis">&#160;bool <a class="name" id="fill_lsize_t_r">fill</a>(size_t <span class="variable">o</span>)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mfill_lsize_t_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line79" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>try to fill the token cache to contain
at least o tokens. Returns false if
there are not enough tokens.</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_paren_l_r">skip_paren</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_paren_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line82" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip till end of paren</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_line_l_r">skip_line</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_line_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line84" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip till end of line</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_attribute_l_r">skip_attribute</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_attribute_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line86" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __attribute__(...), ___asm__(...), ...</p>
</div></div>
<div class="item"><div class="synopsis">&#160;<a href="Token.html#Type" >Token::Type</a> <a class="name" id="skip_extension_lconst.char_S_A_csize_t_A_r">skip_extension</a>(const&#160;char*&amp;, size_t&amp;)  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_extension_lconst.char_S_A_csize_t_A_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line88" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __extension__(...).</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_asm_l_r">skip_asm</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_asm_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line90" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __asm ...</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_declspec_l_r">skip_declspec</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_declspec_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line92" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __declspec(...).</p>
</div></div>
<div class="item"><div class="synopsis">&#160;void <a class="name" id="skip_pragma_l_r">skip_pragma</a>()  </div> <div class="xref"><a href="../../XRef/xref1.html#Synopsis_mLexer_mskip_pragma_l_r" ><img src="../../xref.png" alt="references"/></a></div> <div class="source"><a href="../../Source/Synopsis/Lexer.hh.html#line94" ><img src="../../src-c++.png" alt="source code"/></a></div> <div class="doc"><p>skip __pragma(...);.</p>
</div></div>
</div><!-- detail -->

<div class="logo">Generated on Thu Apr 16 16:27:34 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
